#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	for (int i = 0; i < 50; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(200,550),ofRandom(200,550),0,0);
		particles.push_back(myParticle);
	
	}
	
	for (int i = 0; i < (particles.size()-1); i++){
		spring mySpring;
		mySpring.distance		= 25;
		mySpring.springiness	= 0.2f;
		mySpring.particleA = & (particles[i]);
		mySpring.particleB = & (particles[(i+1)%particles.size()]);
		springs.push_back(mySpring);
		
		//if (i % 20) {
//		particles[i].bFixed = true;
//		}
	}
	
	//particles[particles.size()-1].bFixed = true;


	
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		for (int j = 0; j < particles.size(); j++){
			particles[i].addRepulsionForce(particles[j], 30, .5);
		}
		//particles[i].addForce(0,0.1);
	}
	 
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();
		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	

	ofSetColor(0xffffff);
	
	for (int i = 0; i < particles.size(); i++){
		
		int colorForce = ofMap((particles[i].frc.x+particles[i].frc.y)/2, 0, 1, 0, 255);
		//ofSetColor(colorForce, colorForce, colorForce);
		ofSetColor(0, 0, 0);
		particles[i].draw();
	}
	
	for (int i = 0; i < springs.size(); i++){
		int mappedSpring = ofMap (i, 0, springs.size(), 0, 255);
		int mappedSpringWidth = ofMap (i, 0, springs.size(), 1, 10);
		ofSetLineWidth(mappedSpringWidth);
		ofSetColor(mappedSpring, mappedSpring, mappedSpring);
		springs[i].draw();
	}

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles[0].pos.set(mouseX, mouseY);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	particles[0].bFixed = false;
}

